=== examples/standalone/each_performance/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

project(ign-gazebo-each-performance)

find_package(ignition-gazebo3 QUIET REQUIRED)

add_executable(each each.cc)
target_link_libraries(each
  ignition-gazebo3::core)
